#library "RANDMUS2"
#include "zcommon.acs"
#include "commonFuncs.h" // Even in making a silly music randomizer mod, I require ijon's funcs.

int MusicRandomizerOn;
int MusicInfo;
int MusicCurrentSong;
//Doom2 songs без музыки из tnt и plutonia, добавляйте сами, если считаете нужным
str songsD2[35] = { "D_ADRIAN", "D_AMPIE", "D_BETWEE", "D_COUNT2", "D_COUNTD", "D_DDTBL2", "D_DDTBL3", "D_DDTBLU", "D_DEAD", "D_DEAD2", "D_DM2INT", "D_DM2TTL", "D_DOOM", "D_DOOM2", "D_EVIL", "D_IN_CIT", "D_MESSAG", "D_MESSG2", "D_OPENIN", "D_READ_M", "D_ROMER2", "D_ROMERO", "D_RUNNI2", "D_RUNNIN", "D_SHAWN", "D_SHAWN2", "D_SHAWN3", "D_STALKS", "D_STLKS2", "D_STLKS3", "D_TENSE", "D_THEDA2", "D_THEDA3", "D_THE_DA", "D_ULTIMA"};
//Doom1 songs for e1-e3
str songsD1E1[9] = { "D_E1M1", "D_E1M2", "D_E1M3", "D_E1M4", "D_E1M5", "D_E1M6", "D_E1M7", "D_E1M8", "D_E1M9"};
str songsD1E2[9] = { "D_E2M1", "D_E2M2", "D_E2M3", "D_E2M4", "D_E2M5", "D_E2M6", "D_E2M7", "D_E2M8", "D_E2M9"};
str songsD1E3[9] = { "D_E3M1", "D_E3M2", "D_E3M3", "D_E3M4", "D_E3M5", "D_E3M6", "D_E3M7", "D_E3M8", "D_E3M9"};
int songtoplay;
int numbersong;

#define SONGSTR_INFO 1
#define SONGSTR_SONG 0

function int getSongStr(int SongNumber, int Type)
{
  // if the song amount ever goes over 1000, uncomment everything but this line ...
  int OneZero = "0"; int TwoZeros = "00"; // int ThreeZeros = "000";
  int PrefixString;
  int OutputString;
  
  if(Type == SONGSTR_INFO)
  {
    PrefixString = "JUKEBOX_";
  }
  else if(Type == SONGSTR_SONG)
  {
    PrefixString = "Song";
  }
  else
  {
    PrefixString = "OhGodThisIsAnError";
  }
  
  // ... and remove these blocks
  if(SongNumber <= 9)
  { // if it's less than 10 (1 digit, two zeros)
    OutputString = StrParam(s:PrefixString, s:TwoZeros, d:SongNumber); // concatenate the prefix, two zeros, and the number
  }
  else if(SongNumber <= 99)
  { // if it's less than 100 (2 digits, one zero)
    OutputString = StrParam(s:PrefixString, s:OneZero, d:SongNumber); // concatenate the prefix, one zero, and the number
  }
  else
  { // if it's over 100
    OutputString = StrParam(s:PrefixString, d:SongNumber); // concatenate the prefix and the number
  }
  
  return OutputString;
}

function int getMaxRandSong(void)
{
  int temp;
  int i;
  
  for(i = 1; i < 9999; i++)
  { // Please do not use more than 9999 songs.
    temp = getSongStr(i, SONGSTR_INFO); // Compare the string and the language text,
                                        // if they're the same it's the last one.
    if(!CStrCmp(temp, StrParam(l:temp)))
    {
      return i - 1;
    }
  }
  
  return -1;
}

script 345 OPEN
{
    int r = unusedTID(37000, 47000);

    delay(1);
	//хороший способ для проверки, но... "Doomsphere" есть в сабмоде для LCA :)
    if (SpawnForced("Doomsphere",0,0,0,r,0))
    { Thing_Remove(r); SetCVar("mus_runninginzdoom2",0); }
    else
    { SetCVar("mus_runninginzdoom2",1); }
}

Script 346 OPEN NET clientside
{
  int i;
  int randomhack;
  int lastmus;
if (getMaxRandSong()>0)
{  
  if(GetCvar("nomusic2") == 0)
  {
    MusicRandomizerOn = 1;
    
    if(GetCvar("mus_runninginzdoom2") == 1)
    {
      i = random(1, getMaxRandSong());
      SetMusic(getSongStr(i, SONGSTR_SONG),0);
      MusicCurrentSong = i;
    }
    else
    {
      // [13] Zandronum is funny about this. Online, it generates the same random seed
      // every time, even though that's the opposite of what you'd expect from a random
      // call. I have to use a workaround to generate pseudo-random behavior.
      // But it's better than dealing with ZDoom's barely-functional slapshod netcode!
      
      // [marrub] The reason this happens is the C/S code wants to be extra-deterministic
      // so everyone gets the same (P)RNG. This is a guess. Please don't hit me, Dusk.
      // Also on ZDoom everyone knows they have the same PRNG so there's no worry there.
      
      randomhack = defaultCVar("mus_cl_randomhack", 0);
      lastmus    = defaultCVar("mus_cl_lastmusic",  0) - 1;
      
      for (i = 0; i < randomhack; i++) { random(0, 1); }
      randomhack = random(0, 500);
      SaveCVar("mus_cl_randomhack", randomhack);
      
      do { i = random(1, getMaxRandSong()); }
      while (i == lastmus);
      
      SetMusic(getSongStr(i, SONGSTR_SONG), 0);
      MusicCurrentSong = i;
      SaveCVar("mus_cl_lastmusic", i);
    }
    
    Delay(35);
    
    if(GetCvar("noinfo2") == 0)
    {
      MusicInfo = getSongStr(i, SONGSTR_INFO);
      if(CStrCmp(MusicInfo, StrParam(l:MusicInfo)))
      {                       // This compares the info with the language text it's associated with
        SetFont("SmallFont"); // If it's the same, there is no language text associated with it, thus we should not print it
        hudmessage(l:MusicInfo; HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 0.1, 0.8, 3.0, 0.5, 1.0);
      }
    }
  }
  else
  {
    MusicRandomizerOn = 0;
  }
}
}

script 347 OPEN clientside
{
  delay(1);  
  
  if(GetCvar("mus_runninginzdoom2") == 0) // No option to disable on ZDoom because I'm pretty sure the only way this'll
  {                                      // be happening is when you manually load it, ergo want to listen to it...
    if(!GetCvar("nomusic2"))
    {
      ConsoleCommand("set nomusic2 0");
      ConsoleCommand("archivecvar nomusic2");
    }
    
    if(!GetCvar("noinfo2"))
    {
      ConsoleCommand("set noinfo2 0");
      ConsoleCommand("archivecvar noinfo2");
    }
  }
}

script 348 (int musicshit) NET clientside // Hitting "Next Song".
{
  int i;
  int randomhack;
  int lastmus;
//[mrPron] gzdoom не будет грузить сейвы, если размер acs не совпадает,
//поэтому пришлось делать универсальный acs, работающий как с пустышкой,
//так и с модами, наполненными песнями (для моего "Brutalizer"). 
//Соответственно, ниже идёт проверка,
//пустой ли это мод для переключения ванильных треков или не пустой.
  if (getMaxRandSong()>0) //если это не пустышка
{
  switch (musicshit)
  {
    case 0:
      SetMusic("silence");
      LocalAmbientSound("music/shift",127);
      Delay(35);
        MusicRandomizerOn = 1;
        if (GetCvar("mus_runninginzdoom2") == 1)
        {
          i = random(1, getMaxRandSong());
          SetMusic(getSongStr(i, SONGSTR_SONG),0);
          MusicCurrentSong = i;
        }
        else
        {
          randomhack = defaultCVar("mus_cl_randomhack",   0);
          lastmus    = defaultCVar("mus_cl_lastmusic",    0) - 1;
          
          for (i = 0; i < randomhack; i++) { random(0, 1); }
          randomhack = random(0, 500);
          SaveCVar("mus_cl_randomhack", randomhack);
          
          do { i = random(1, getMaxRandSong()); }
          while (i == lastmus);
          
          SetMusic(getSongStr(i, SONGSTR_SONG), 0);
          MusicCurrentSong = i;
          SaveCVar("mus_cl_lastmusic", i + 1);
        }
        if (GetCvar("noinfo2") == 0)
        {
          MusicInfo = getSongStr(i, SONGSTR_INFO);
          if(CStrCmp(MusicInfo, StrParam(l:MusicInfo)))
          {
            SetFont("SmallFont");
            hudmessage(l:MusicInfo; HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 0.1, 0.8, 3.0, 0.5, 1.0);
          }
        }
      break;

    case 1: // Hitting "Mute Song".
      SetMusic("silence");
      LocalAmbientSound("music/shift",127);
      Delay(35);
      hudmessage(l:"SILENCE"; HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 0.1, 0.8, 3.0, 0.5, 1.0);
      break;
	case 2: // Hitting "Default Song".
      SetMusic("silence");
      LocalAmbientSound("music/shift",127);
      Delay(35);
	  hudmessage(l:"DEFAULT_SONG"; HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 0.1, 0.8, 3.0, 0.5, 1.0);
      SetMusic("*",0);
      break;
  }
 }
else //код для пустышки т.е. для данного файла ;)(for vanila randomizer)
 {
 int lumpmapname = strparam(n:-2);//mapname lump
	//If mapname "ExMx" - Doom1, "Mapxx" - Doom2
	switch (musicshit)
  {
    case 0:
	SetMusic("silence");
	if (StrICmp(lumpmapname, "E", 1)==0) //Doom1
	{
	 songtoplay = random(0, 8); //индексация начинается с нуля
	 numbersong = songtoplay+1; //но игроку об этом знать не обязательно
	 int episodeNumber = StrMid(lumpmapname, 1, 1);//второй символ из mapname
	 if (episodeNumber == "1"){
	  hudmessage(l:strparam(l:"RENDOM_SONG", i:numbersong); HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 0.1, 0.8, 3.0, 0.5, 1.0);
      LocalAmbientSound("music/shift",127);
      Delay(35);
	  SetMusic(songsD1E1[songtoplay],0);
	 }
	 else if (episodeNumber == "2"){
	  hudmessage(l:strparam(l:"RENDOM_SONG", i:numbersong); HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 0.1, 0.8, 3.0, 0.5, 1.0);
      LocalAmbientSound("music/shift",127);
      Delay(35);
	  SetMusic(songsD1E2[songtoplay],0);
	 }
	 else if (episodeNumber == "3"){
	  hudmessage(l:strparam(l:"RENDOM_SONG", i:numbersong); HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 0.1, 0.8, 3.0, 0.5, 1.0);
      LocalAmbientSound("music/shift",127);
      Delay(35);
	  SetMusic(songsD1E3[songtoplay],0);
	 }
	 //e4-e5-e6... no way. сами возитесь, пытаясь угадать, есть ли в wadе D_E4Mx
	 else {
	  LocalAmbientSound("music/shift",127);
	  hudmessage(l:strparam(l:"NO_RENDOM_SONG", s:lumpmapname); HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 0.1, 0.8, 3.0, 0.5, 1.0);
      Delay(35);
	  SetMusic("*");
	 }
	}
	else //Doom2
	{
	 songtoplay = random(0, 34);
	 numbersong = songtoplay+1;
	 hudmessage(l:strparam(l:"RENDOM_SONG", i:numbersong); HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 0.1, 0.8, 3.0, 0.5, 1.0);
     LocalAmbientSound("music/shift",127);
     Delay(35);
	 SetMusic(songsD2[songtoplay],0);
	}	
	 break;
    case 1: // Hitting "Mute Song".
      SetMusic("silence");
      LocalAmbientSound("music/shift",127);
      Delay(35);
      hudmessage(l:"SILENCE"; HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 0.1, 0.8, 3.0, 0.5, 1.0);
      break;
	case 2: // Hitting "Default Song".
      SetMusic("silence");
      LocalAmbientSound("music/shift",127);
      Delay(35);
	  hudmessage(l:"DEFAULT_SONG"; HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 0.1, 0.8, 3.0, 0.5, 1.0);
      SetMusic("*",0);
      break;
  }
 }
}
